<template>
  <CommandExecuteContext v-bind:commands="commandContext"></CommandExecuteContext>
</template>

<script>
  import UserCommands from "../../../commands/UserCommands"
  import CommandExecuteContext from '../../../commands/CommandExecuteContext'
  import UserGroupService from '../../../domain/services/UserGroupService'
  import HelperUtil from "../../../utils/HelperUtil";

  export default {
    props: ['command'],

    components: {
      CommandExecuteContext,
    },

    created() {
      this.confirmUserCommand.execute();
    },

    data() {
      return {
        deleteList: this.command.target,

        //命令
        commandContext: {},

        confirmFlag: {
          confirm: false,
        },
      }
    },

    methods: {
      open() {
        let _this = this;
        _this.InfoTip.conformTip(_this, HelperUtil.getCheckStatusCodeObjectByCode(_this.successCode.DELETE_CONFIRM)).then(() => {
          _this.deleteUserGroup()
        }).catch(()=>{
          _this.close()
        });
      },

      close(){
        this.command.done()
      },

      //删除用户组
      deleteUserGroup() {
        let _this = this;
        let loadingInstance = _this.Loading.openLoading();
        UserGroupService.deleteUserGroup(this.deleteList).then(result => {
          //成功
          _this.Loading.closeLoading(loadingInstance);
          _this.InfoTip.successTip(_this,HelperUtil.getStatusCodeObjectByCode(_this.successCode.DELETE_CODE));
          _this.close()
        }).catch(err => {
          //失败
          _this.Loading.closeLoading(loadingInstance);
          _this.InfoTip.errorTip(_this, err);
          _this.close()
        })
      }
    },

    watch: {
      commandContext (newVal, oldVal){
        let _this = this;
        if(_this.confirmFlag.confirm){
          this.open();
          this.confirmFlag.confirm = false
        }
        else{
          if(JSON.stringify(newVal) === '{}'){
            _this.close()
          }
        }
        deep: true
      },
    },

    computed: {
      confirmUserCommand(){
        this.confirmFlag.confirm = false;
        return UserCommands.confirmUserCommand(this.commandContext, this.confirmFlag)
      },
    },
  }
</script>

<style scoped>

</style>
